﻿@model LoyaltyPointEngine.Model.Parameter.Receipt.UploadReceiptCMSModel
@{
    List<SelectListItem> channelList = (List<SelectListItem>)ViewBag.ChannelList;

}
<!--=== Page Content ===-->
<div class="row">
    <div class="col-md-12">
        <h5 class="widget-title"><i class="icon-sign-blank"></i>Add Receipt</h5>
    </div>
</div>
@using (Html.BeginForm(MVC.Receipt.AddJson(), FormMethod.Post, new { enctype = "multipart/form-data", @class = "form-horizontal row-border", @id = "formAddReceipt" }))
{

    <div class="row">
        <!--=== Validation Example 1 ===-->
        <div class="col-md-12">
            <div class="widget box">
                <div class="widget-header">
                    <h4><i class="icon-reorder"></i>Receipt Header</h4>
                </div>
                <div class="widget-content">
                    @Html.AntiForgeryToken()
                    <div class="error-widget alert alert-danger" style="display: none">
                        <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                        <i class="fa fa-times-circle"></i>
                        Error occured:
                        <br />
                        <div class="message-error-detail">
                            @Html.ValidationSummary()
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Member <span class="required">*</span></label>
                        <div class="col-md-6">
                            @Html.HiddenFor(x => x.MemberID)
                            @Html.TextBoxFor(x => x.MemberName, new { @class = "form-control", @readonly = "", @required = "" })
                        </div>
                        <button type="button" class="col-md-3 btn btn-primary" data-toggle="modal" data-target="#memberModal" data-whatever="lala">Select Member</button>
                    </div>
                    @*<div class="form-group">
            <label class="col-md-3 control-label">Code <span class="required">*</span></label>
            <div class="col-md-9">
                @Html.TextBoxFor(x => x.Code, new { @class = "form-control", @required = "" })
            </div>
        </div>*@
                    <div class="form-group">
                        <label class="col-md-3 control-label">Receipt Code </label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.ReceiptCode, new { @class = "form-control" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Kode Event </label>
                        <div class="col-md-9">
                            @Html.DropDownListFor(x => x.EventCode, ViewBag.ListEventCode as IEnumerable<SelectListItem>, "", new { @class = "select2-select-00 col-md-12 full-width-fix" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Retailer <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.DropDownListFor(x => x.RetailerID, ViewBag.ListRetailer as IEnumerable<SelectListItem>, "", new { @class = "select2-select-00 col-md-12 full-width-fix", @required = "required" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Retailer Address <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.TextAreaFor(x => x.RetailerAddress, new { @class = "form-control", @required = "" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Transaction Date <span class="required">*</span></label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.StrTransactionDate, new { @class = "form-control datepicker", @required = "required" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Transaction Time <span class="required">*</span></label>
                        <div class="col-md-3">
                            <input type="text" id="StrTransactionTime" name="StrTransactionTime" class="form-control" data-mask="99:99:99" required><span class="help-block">HH:MM:SS</span>
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Request Date </label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.StrRequestDate, new { @class = "form-control datepicker" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Campaign</label>
                        <div class="col-md-3">
                            @Html.DropDownListFor(x => x.CampaignID, ViewBag.ListCampaign as IEnumerable<SelectListItem>, "", new { @class = "select2-select-00 col-md-12 full-width-fix" })
                        </div>
                    </div>
                    <div id="image-box">
                        <input type="hidden" id="TotalImage" value="1" />
                        <div class="form-group image-obj-1">
                            <label class="col-md-3 control-label">Receipt Image </label>
                            <div class="col-md-4">
                                <input type='file' id='Image-1' class="form-control ImageReceipt" name="Image" />
                            </div>
                            <div class="col-md-5" style="padding-top: 7px;">
                                <button id="view-Image-1" type="button" class="btn btn-primary view-image" onclick="readURL(document.getElementById('Image-1'))" data-toggle="modal" data-target="#imageViewer" style="display:none">View</button>
                                <button type="button" class="btn btn-success" onclick="ReceiptAddImage()">Add</button>
                                @* <button type="button" class="btn btn-danger" onclick="ReceiptRemoveImage(1)">Remove</button>*@
                            </div>
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Channel <span class="required">*</span></label>
                        <div class="col-md-3">
                            @Html.DropDownListFor(x => x.Channel, channelList, "", new { @class = "select2-select-00 col-md-12 full-width-fix", @required = "required" })
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-md-3 control-label">Total Price </label>
                        <div class="col-md-9">
                            @Html.TextBoxFor(x => x.TotalPrice, new { @class = "form-control" })
                        </div>
                    </div>
                    <input id="TotalAction" name="TotalAction" type="hidden" value="1">
                    <div style="display: none">
                        @Html.DropDownListFor(x => x.ActionDummy, ViewBag.ListAction as IEnumerable<SelectListItem>, "", new { @class = "select2-select-00 col-md-12 full-width-fix" })
                    </div>
                </div>
            </div>
            <!-- /Validation Example 1 -->
        </div>
    </div>

    <div id="action-box">
        <div class="row action-obj-1">
            <div class="col-md-12">
                <div class="widget box">
                    <div class="widget-header">
                        <h4><i class="icon-reorder"></i>Receipt Detail</h4>
                        <!-- Toolbar -->
                        @*<div class="toolbar no-padding">
                                <div class="btn-group" onclick="removeAction(1)">
                                    <span class="btn btn-xs"><i class="icon-minus"></i> Remove</span>
                                </div>
                            </div>*@
                        <!-- /Toolbar -->
                    </div>
                    <div class="widget-content">
                        <div class="form-group">
                            <label class="col-md-3 control-label">Action <span class="required">*</span></label>
                            <div class="col-md-9">
                                <select id="ActionID-1" name="ActionID-1" class="select2-select-00 col-md-12 full-width-fix" onchange="GetActionValue(this.value, 1)" required>
                                    <option></option>
                                    @foreach (SelectListItem item in ViewBag.ListAction)
                                    {
                                        <option value="@item.Value">@item.Text</option>
                                    }
                                </select>
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-md-3 control-label">Child</label>
                            <div class="col-md-9">
                                <select id="ChildID-1" name="ChildID-1" class="select2-select-00 col-md-12 full-width-fix">
                                    <option selected></option>
                                </select>
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="col-md-3 control-label">Quantity <span class="required">*</span></label>
                            <div class="col-md-9">
                                <input class="form-control ipt-number" id="Quantity-1" name="Quantity-1" onchange="SetTotalPoint(this.value, 1)" required type="tel">
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-md-3 control-label">Points</label>
                            <div class="col-md-9">
                                <input class="form-control ipt-number" id="Points-1" name="Points-1" readonly="" type="tel">
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-md-3 control-label">Quantity Approved</label>
                            <div class="col-md-9">
                                <input class="form-control ipt-number" id="QuantityApproved-1" name="QuantityApproved-1" onchange="SetTotalQuantityPoint(this.value, 1)" type="tel" required>
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-md-3 control-label">Total Quantity Approved Points</label>
                            <div class="col-md-9">
                                <input class="form-control TotalQuantityApproved ipt-number" id="TotalQuantityApprovedPoints-1" name="TotalQuantityApprovedPoints-1" readonly="" type="tel">
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-md-3 control-label">Item Price</label>
                            <div class="col-md-9">
                                <input class="form-control ipt-number" id="ItemPrice-1" name="ItemPrice-1" type="tel">
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-md-3 control-label">Remarks</label>
                            <div class="col-md-9">
                                <textarea class="form-control" id="Remarks-1" name="Remarks-1"></textarea>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="row">
        <div class="col-md-12 ta-center">
            <div class="col-md-2">
                <a href="javascript:void(0)" onclick="addAction()" class="btn button big red"><span class="glyphicon additional plus margin-right-10"></span>Add More Detail</a>
            </div>
            <label class="col-md-1 control-label">Total Points </label>
            <div class="col-md-2">
                <input class="form-control" id="TotalAllPoint" name="TotalAllPoint" type="text" value="0" readonly>
            </div>
            @*<label class="col-md-1 control-label">Max Points </label>
                <div class="col-md-2">
                    <input class="form-control" id="MaxPoint" name="TotalAllPoint" type="text" value=0 readonly>
                </div>*@
            <div class="col-md-3">
                <input type="button" value="Submit" class="btn btn-primary pull-right" id="btn-submit" />
            </div>
        </div>
    </div>
    <div class="row">
        <br />
    </div>
}

<div class="modal fade" id="memberModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel">
    <div class="modal-dialog" style="width: auto !important" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title" id="exampleModalLabel">Select Member</h4>
            </div>
            <div class="modal-body">
                @Html.Action("GridGetSelectMemberPager", "Member", new { page = 1 })
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="imageViewer" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title" id="exampleModalLabel">View Image</h4>
            </div>
            <div class="modal-body">
                <div>
                    <img id="blah" src="#" alt="your image" />
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>

@section FooterScript{
<script type="text/javascript">
        function GetAllTotalPoint() {
            var total = 0;
            $('.TotalQuantityApproved').each(function () {
                //total += parseInt(this.value);
                var val = 0;
                if ($(this).val()) val = parseInt($(this).val());
                //total += parseInt(this.value);
                total += val;
            });
            return total;
        }
        function readURL(input) {
            if (input.files && input.files[0]) {
                var reader = new FileReader();

                reader.onload = function (e) {
                    $('#blah').attr('src', e.target.result);
                }
                reader.readAsDataURL(input.files[0]);
            }
        }
        //(function () {
        //    var gridName = 'GridSelectMember';
        //    var pagingUrl = '@Url.Action(MVC.Member.GridGetSelectMemberPager())';
        //
        //    $('.grid-mvc').gridmvc();
        //    pageGrids[gridName].ajaxify({
        //        getData: pagingUrl,
        //        getPagedData: pagingUrl,
        //        gridFilterForm: $('#gridSeachMember')
        //    });
        //}())

        //function ini dipanggil sama popup Member
        function SelectMember(MemberID, MemberName) {
            $('#MemberID').val(MemberID);
            $('#MemberName').val(MemberName);
            $('#memberModal').modal('hide');
            //_url = '';
            //$.ajax({
            //    url: _url,
            //    success: function (msg) {
            //        $('#MaxPoint').val(msg.points)
            //    },
            //    error: function (jqXHR, textStatus) {
            //        alert('Error Occured');
            //    }
            //})
        };
        function GetActionValue(val, index) {
            _url = '@Url.Action(MVC.Action.GetActionValueById(999999999))';
            _url = _url.replace("999999999", val);
            $.ajax({
                url: _url,
                timeout: 30000,
                success: function (msg) {
                    $('#Points-' + index).val(msg.value);
                    $('#QuantityApproved-' + index).val(0);
                    $('#TotalQuantityApprovedPoints-' + index).val(msg.value);
                    var _TotalPoint = GetAllTotalPoint();
                    $('#TotalAllPoint').val(_TotalPoint);

                    if (!msg.isPregnancyProduct) {
                        _url = '@Url.Action(MVC.Member.GetAllChild(99999999))';
                        _url = _url.replace('99999999', $('#MemberID').val());
                        $.ajax({
                            url: _url,
                            timeout: 30000,
                            success: function (data) {
                                if (data.statusCode == '00') {
                                    $('#ChildID-' + index + ' option').remove();
                                    $('#ChildID-' + index).append('<option selected></option>');
                                    $.each(data.list, function (i, v) {
                                        $('#ChildID-' + index).append('<option value="' + v.ChildID + '">' + v.ChildName + '</option>');
                                    });
                                }
                                $('#ChildID-' + index).closest('.form-group').show();
                            }
                        });
                    } else {
                        $('#ChildID-' + index).closest('.form-group').hide();
                    }
                },
                error: function (jqXHR, textStatus) {
                    alert('Error Occured'); //MESSAGE
                }
            })
        }

        function SetTotalPoint(val, index) {
            var actionPoint = $('#Points-' + index).val();
            var total = actionPoint * val;
            $('#QuantityApproved-' + index).val(val);
            $('#TotalQuantityApprovedPoints-' + index).val(total);
            var _TotalPoint = GetAllTotalPoint();
            $('#TotalAllPoint').val(_TotalPoint);

        }
        function SetTotalQuantityPoint(val, index) {
            var actionPoint = parseInt($('#Points-' + index).val());
            var quantityVal = parseInt($('#Quantity-' + index).val());
            if (val > quantityVal) {
                alert('Quantity Approved should be less than or equal to Quantity');
                $('#QuantityApproved-' + index).val(quantityVal);
            } else {
                var total = actionPoint * val;
                $('#TotalQuantityApprovedPoints-' + index).val(total);
                var _TotalPoint = GetAllTotalPoint();
                $('#TotalAllPoint').val(_TotalPoint);
            }
        }


        //validation
        $(document).ready(function () {
            $('#ChildID-1').closest('.form-group').hide();
            $('.ImageReceipt').change(function () {
                ValidateImageRecieipt(this);
            });

            //===== Validation =====//
            //for default options, see assets/js/plugins.form-components.js (initValidation())

            $.extend($.validator.defaults, {
                invalidHandler: function (form, validator) {
                    var errors = validator.numberOfInvalids();
                    if (errors) {
                        var message = errors == 1
                        ? 'You missed 1 field. It has been highlighted.'
                        : 'You missed ' + errors + ' fields. They have been highlighted.';
                        noty({
                            text: message,
                            type: 'error',
                            timeout: 2000
                        });
                    }
                },
                errorPlacement: function (error, element) {
                    if (element.attr('type') === "file" && element.data('style') === "fileinput") {
                        error.appendTo(element.closest("div.fileinput-holder").parent('div'));
                    } else {
                        error.insertAfter(element)
                    }
                }
            });

            $('input[name=ReceiptCode]').on('blur', function (e) {
                if ($(this).val().length > 3) {
                    //var url = window.location.href;
                    //url = url.replace("/Receipt/Add", "");
                    $.ajax({
                        type: "post",
                        url: "@Url.Action(MVC.Receipt.CheckDuplicateReceiptCode())",
                        data: { "ReceiptCode": $(this).val() },
                        success: function (data) {
                            if (data != "") {
                                alert(ParseDom(data));
                            }
                            HideLoader();
                        },
                        error: function (request, status, error) {
                            alert(ParseDom(request.responseText));
                            HideLoader();
                        }
                    });
                }
            });

            $('#btn-submit').click(function () {
                if (validateSizeImage() && $("#formAddReceipt").valid()) {
                    $("#formAddReceipt").submit();
                }
            });

            $(document).on('click', '#btn-retry-submit-form', function () {
                if (validateSizeImage() && $("#formAddReceipt").valid()) {
                    $("#formAddReceipt").submit();
                }
            });

            $("#formAddReceipt").submit(function (ev) {
                $('.error-widget').hide();
                ev.preventDefault();
                ShowLoader();
                var formData = new FormData($(this)[0]);
                console.log(formData);
                $.ajax({
                    type: $(this).attr('method'),
                    url: $(this).attr('action'),
                    cache: false,
                    contentType: false,
                    processData: false,
                    async: false,
                    data: formData,
                    success: function (data) {
                        console.log(data);
                        HideLoader();
                        var strAlert = '';
                        strAlert += data.Message;

                        if (data.IsSuccess) {

                            alert(ParseDom(strAlert));
                            window.location.href = "@Url.Action(MVC.Receipt.Index())";
                        } else {
                            if (data.IsNeedRetry != undefined && data.IsNeedRetry) {
                                $('#MemberName').focus();
                                $('.error-widget').show();
                                strAlert += "<br/><button value='Retry' id='btn-retry-submit-form' type='button' class='btn btn-primary' style='height:30px;'>Retry Submit</button>";
                                $('.message-error-detail').html(strAlert);
                            } else {
                                $('#MemberName').focus();
                                $('.error-widget').show();
                                $('.message-error-detail').html(strAlert);
                            }
                        }
                    },
                    error: function (request, status, error) {
                        //alert(request.responseText);
                        var strAlert = '';
                        if (request.responseText != undefined && request.responseText != '') {
                            strAlert += request.responseText;
                        } else if (request.statusText != undefined && request.statusText != '') {
                            strAlert += request.statusText;
                        } else {
                            strAlert += 'Error occured when submit data';
                        }

                        $('#MemberName').focus();
                        $('.error-widget').show();
                        strAlert += "<br/><button value='Retry' id='btn-retry-submit-form' type='button' class='btn btn-primary' style='height:30px;'>Retry Submit</button>";
                        $('.message-error-detail').html(strAlert);
                        HideLoader();
                    }
                });

            });

            function LoadGridFunctions() {
                function LoadData(dataUrl) {
                    if (dataUrl) {
                        $.ajax({
                            url: dataUrl,
                            complete: function (xhr, status) {
                                if (status === 'success') {
                                    $('div#memberModal .modal-body').html(xhr.responseText);
                                } else {
                                    alert(ParseDom(status + ' : ' + xhr.responseText));
                                }
                                LoadGridFunctions();
                            }
                        })
                    }
                }

                $('#grid-select-member div.grid-header-title > a, #grid-select-member .grid-footer ul.pagination li > a').on('click', function (e) {
                    e.preventDefault();
                    var dataUrl = $(this).data('url');
                    LoadData(dataUrl);
                })

                $('form[name=grid-select-member-form]').on('submit', function (e) {
                    e.preventDefault();
                    //e.stopPropagation();
                    HideLoader();
                    var dataUrl = decodeURIComponent($(this).find('[type=hidden][name=rawDataUrl]').val()).replace('@@search@@', $(this).find('[type=text][name=txtSearch]').val());
                    LoadData(dataUrl);
                })
            }
            LoadGridFunctions();
        });

        function validateSizeImage() {
            $('.error-widget').hide();
            var result = true;
            var strAlert = '<ul>';

            $('.ImageReceipt').each(function () {
                if (this.files != null && this.files.length > 0) {
                    $(this).attr('style', 'border-color:#ccc');
                    console.log(this.files[0]);
                    var extension = this.files[0].name.replace(/^.*\./, '');
                    var size = this.files[0].size;
                    var mb = (size / 1000000).toFixed(2)
                    console.log(mb + ' MB');
                    var fileExtension = ['jpeg', 'jpg', 'png', 'gif', 'bmp'];
                    if ($.inArray($(this).val().split('.').pop().toLowerCase(), fileExtension) == -1) {
                        result = false;
                        var messge = "Only formats are allowed : " + fileExtension.join(', ');
                        strAlert += '<li>' + messge + '</li>';
                        $(this).attr('style', 'border-color:red');
                    }

                    if (mb > 5) {
                        result = false;
                        var messge = "Max size per File is 5 MB";
                        strAlert += '<li>' + messge + '</li>';
                        $(this).attr('style', 'border-color:red');
                    }
                }
            });

            strAlert += '</ul>';
            if (!result) {
                $('#MemberName').focus();
                $('.error-widget').show();
                $('.message-error-detail').html(strAlert);
            }
            return result;
        }

        function ValidateImageRecieipt(element) {
            var elementid = $(element).attr('id');
            $('#view-' + elementid).hide();
            $('.error-widget').hide();
            var result = true;
            var strAlert = '<ul>';
            if (element.files != null && element.files.length > 0) {
                $(element).attr('style', 'border-color:#ccc');
                var extension = element.files[0].name.replace(/^.*\./, '');
                var size = element.files[0].size;
                var mb = (size / 1000000).toFixed(2)
                var fileExtension = ['jpeg', 'jpg', 'png', 'gif', 'bmp'];
                if ($.inArray($(element).val().split('.').pop().toLowerCase(), fileExtension) == -1) {
                    result = false;
                    var messge = "Only formats are allowed : " + fileExtension.join(', ');
                    strAlert += '<li>' + messge + '</li>';
                    $(element).attr('style', 'border-color:red');
                }

                if (mb > 5) {
                    result = false;
                    var messge = "Max size per File is 5 MB";
                    strAlert += '<li>' + messge + '</li>';
                    $(element).attr('style', 'border-color:red');
                }
                strAlert += '</ul>';
            } else {
                result = false;
            }

            if (!result) {
                $('#MemberName').focus();
                $('.error-widget').show();
                $('.message-error-detail').html(strAlert);
            } else {
                $('#view-' + elementid).show();
            }
        }
</script>
}